#define MIN(a,b)      ( ((a)<(b)) ? (a) : (b) )
#define MAX(a,b)      ( ((a)<(b)) ? (b) : (a) )
#define ABS(a)        ( ((a)<0.0) ? -(a) : (a))
#include <math.h>

/* Subroutine */ void dpptri_(char *uplo, int *n, LONG DOUBLE *ap, int *
	info)
{
/*  -- LAPACK routine (version 2.0) --   
       Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,   
       Courant Institute, Argonne National Lab, and Rice University   
       March 31, 1993   


    Purpose   
    =======   

    DPPTRI computes the inverse of a real symmetric positive definite   
    matrix A using the Cholesky factorization A = U**T*U or A = L*L**T   
    computed by DPPTRF.   

    Arguments   
    =========   

    UPLO    (input) CHARACTER*1   
            = 'U':  Upper triangular factor is stored in AP;   
            = 'L':  Lower triangular factor is stored in AP.   

    N       (input) INTEGER   
            The order of the matrix A.  N >= 0.   

    AP      (input/output) LONG DOUBLE PRECISION array, dimension (N*(N+1)/2) 
  
            On entry, the triangular factor U or L from the Cholesky   
            factorization A = U**T*U or A = L*L**T, packed columnwise as 
  
            a linear array.  The j-th column of U or L is stored in the   
            array AP as follows:   
            if UPLO = 'U', AP(i + (j-1)*j/2) = U(i,j) for 1<=i<=j;   
            if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = L(i,j) for j<=i<=n.   

            On exit, the upper or lower triangle of the (symmetric)   
            inverse of A, overwriting the input factor U or L.   

    INFO    (output) INTEGER   
            = 0:  successful exit   
            < 0:  if INFO = -i, the i-th argument had an illegal value   
            > 0:  if INFO = i, the (i,i) element of the factor U or L is 
  
                  zero, and the inverse could not be computed.   

    ===================================================================== 
  


       Test the input parameters.   

    
   Parameter adjustments   
       Function Body */
    /* Table of constant values */
    static LONG DOUBLE c_b8 = 1.;
    static int c__1 = 1;
    
    /* System generated locals */
    int i__1, i__2;
    /* Local variables */
    extern LONG DOUBLE ddot_(int *, LONG DOUBLE *, int *, LONG DOUBLE *, 
	    int *);
    extern /* Subroutine */ void dspr_(char *, int *, LONG DOUBLE *, 
	    LONG DOUBLE *, int *, LONG DOUBLE *);
    static int j;
    extern /* Subroutine */ void dscal_(int *, LONG DOUBLE *, LONG DOUBLE *, 
	    int *);
    extern long int lsame_(char *, char *);
    extern /* Subroutine */ void dtpmv_(char *, char *, char *, int *, 
	    LONG DOUBLE *, LONG DOUBLE *, int *);
    static long int upper;
    static int jc, jj;
    extern /* Subroutine */ void xerbla_(char *, int *), dtptri_(
	    char *, char *, int *, LONG DOUBLE *, int *);
    static LONG DOUBLE ajj;
    static int jjn;



#define AP(I) ap[(I)-1]


    *info = 0;
    upper = lsame_(uplo, "U");
    if (! upper && ! lsame_(uplo, "L")) {
	*info = -1;
    } else if (*n < 0) {
	*info = -2;
    }
    if (*info != 0) {
	i__1 = -(*info);
	xerbla_("DPPTRI", &i__1);
	return;
    }

/*     Quick return if possible */

    if (*n == 0) {
	return;
    }

/*     Invert the triangular Cholesky factor U or L. */

    dtptri_(uplo, "Non-unit", n, &AP(1), info);
    if (*info > 0) {
	return;
    }

    if (upper) {

/*        Compute the product inv(U) * inv(U)'. */

	jj = 0;
	i__1 = *n;
	for (j = 1; j <= *n; ++j) {
	    jc = jj + 1;
	    jj += j;
	    if (j > 1) {
		i__2 = j - 1;
		dspr_("Upper", &i__2, &c_b8, &AP(jc), &c__1, &AP(1));
	    }
	    ajj = AP(jj);
	    dscal_(&j, &ajj, &AP(jc), &c__1);
/* L10: */
	}

    } else {

/*        Compute the product inv(L)' * inv(L). */

	jj = 1;
	i__1 = *n;
	for (j = 1; j <= *n; ++j) {
	    jjn = jj + *n - j + 1;
	    i__2 = *n - j + 1;
	    AP(jj) = ddot_(&i__2, &AP(jj), &c__1, &AP(jj), &c__1);
	    if (j < *n) {
		i__2 = *n - j;
		dtpmv_("Lower", "Transpose", "Non-unit", &i__2, &AP(jjn), &AP(
			jj + 1), &c__1);
	    }
	    jj = jjn;
/* L20: */
	}
    }

    return;

/*     End of DPPTRI */

} /* dpptri_ */

